package ee.yoursit.core.command.bukkit.impl.admin.group;

import dev.inventex.octa.data.convertible.Convertible;
import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.command.bukkit.api.Argument;
import ee.yoursit.core.command.bukkit.api.CommandContext;
import ee.yoursit.core.command.bukkit.api.CommandInfo;
import ee.yoursit.core.config.Messages;
import ee.yoursit.core.database.entity.api.EntitySerializer;
import ee.yoursit.core.database.entity.impl.Group;
import org.jetbrains.annotations.NotNull;

import java.util.HashMap;

@CommandInfo(name = "create")
public class CreateArgument extends Argument {
    @Override
    public void onCommand(@NotNull CommandContext context) throws Exception {
        if (!(context.getSender().hasPermission("ysmp.admin"))) {
            context.reply(Messages.NO_PERMISSION);
            return;
        }

        Convertible<String, String> nameArg = context.getString(0);
        if (nameArg.isEmpty()) {
            context.reply(Messages.GROUP_CREATE_USAGE);
            return;
        }

        String name = nameArg.get();

        YsmpCore.INSTANCE
            .getGroupService()
            .getGroup(name)
            .then(group -> context.reply(Messages.GROUP_CREATE_ALREADY_EXISTS
                .replace("{group}", name)))
            .tryExcept(err -> createGroup(context, name));
    }

    private void createGroup(CommandContext context, String name) throws Exception {
        Group group = EntitySerializer.init(Group.class);

        group.getName().init(name);
        group.getPermissions().init(new HashMap<>());

        YsmpCore.INSTANCE
            .getGroupService()
            .addGroup(group)
            .get();

        context.reply(Messages.GROUP_CREATE_CREATED
            .replace("{group}", name));
    }
}
