package ee.yoursit.core.command.bukkit.impl.admin.group;

import dev.inventex.octa.data.convertible.Convertible;
import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.command.bukkit.api.Command;
import ee.yoursit.core.command.bukkit.api.CommandContext;
import ee.yoursit.core.command.bukkit.api.CommandInfo;
import ee.yoursit.core.config.Messages;
import org.jetbrains.annotations.NotNull;

@CommandInfo(name = "delete")
public class DeleteArgument extends Command {
    @Override
    public void onCommand(@NotNull CommandContext context) throws Exception {
        if (!(context.getSender().hasPermission("ysmp.admin"))) {
            context.reply(Messages.NO_PERMISSION);
            return;
        }

        Convertible<String, String> nameArg = context.getString(0);
        if (nameArg.isEmpty()) {
            context.reply(Messages.GROUP_CREATE_USAGE);
            return;
        }

        String name = nameArg.get();

        YsmpCore.INSTANCE
            .getGroupService()
            .getGroup(name)
            .tryThen(group -> {
                if (group == null) {
                    context.reply(Messages.GROUP_DELETE_NOT_EXISTS
                        .replace("{group}", name));
                    return;
                }

                deleteGroup(context, name);
            })
            .except(System.err::println);
    }

    private void deleteGroup(CommandContext context, String name) throws Exception {
        YsmpCore.INSTANCE
            .getGroupService()
            .removeGroup(name)
            .get();

        context.reply(Messages.GROUP_DELETE_DELETED
            .replace("{group}", name));
    }
}
