package ee.yoursit.core.command.bukkit.impl.admin.group;

import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.command.bukkit.api.Argument;
import ee.yoursit.core.command.bukkit.api.CommandContext;
import ee.yoursit.core.command.bukkit.api.CommandInfo;
import ee.yoursit.core.config.Messages;
import ee.yoursit.core.database.entity.impl.Group;
import org.jetbrains.annotations.NotNull;

import java.util.Collection;
import java.util.stream.Collectors;

@CommandInfo(name = "list")
public class ListArgument extends Argument {
    @Override
    public void onCommand(@NotNull CommandContext context) throws Exception {
        if (!(context.getSender().hasPermission("ysmp.admin"))) {
            context.reply(Messages.NO_PERMISSION);
            return;
        }

        Collection<Group> groups = YsmpCore.INSTANCE
            .getGroupService()
            .getGroupCache()
            .values();

        if (groups.isEmpty()) {
            context.reply(Messages.GROUP_NO_GROUPS);
            return;
        }

        String list = groups
            .stream()
            .map(group -> group.getName().get())
            .collect(Collectors.joining(", "));

        context.reply(Messages.GROUP_LIST
            .replace("{list}", list));
    }
}
