package ee.yoursit.core.command.bukkit.impl.home;

import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.command.bukkit.api.Command;
import ee.yoursit.core.command.bukkit.api.CommandContext;
import ee.yoursit.core.command.bukkit.api.CommandInfo;
import ee.yoursit.core.config.Messages;
import ee.yoursit.core.data.PlayerData;
import org.bukkit.Location;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

@CommandInfo(name = "delhome")
public class DelHomeCommand extends Command {
    @Override
    public void onCommand(@NotNull CommandContext context) {
        Player player = context.getPlayer();
        PlayerData data = YsmpCore.INSTANCE
            .getDataManager()
            .get(player);

        data
            .getUser()
            .then(user -> {
                if (user.getHome().get() == null) {
                    context.reply(Messages.HOME_NOT_SET);
                    return;
                }

                user.getHome().set(null);
                context.reply(Messages.HOME_DELETED);
            })
            .except(e -> context.reply(Messages.INTERNAL_ERROR));
    }
}
