package ee.yoursit.core.command.bukkit.impl.home;

import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.command.bukkit.api.Command;
import ee.yoursit.core.command.bukkit.api.CommandContext;
import ee.yoursit.core.command.bukkit.api.CommandInfo;
import ee.yoursit.core.command.bukkit.api.Completion;
import ee.yoursit.core.config.Messages;
import ee.yoursit.core.data.PlayerData;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

@CommandInfo(name = "sethome")
public class SetHomeCommand extends Command {
    @Override
    public void onCommand(@NotNull CommandContext context) {
        Player player = context.getPlayer();
        PlayerData data = YsmpCore.INSTANCE
            .getDataManager()
            .get(player);

        data
            .getUser()
            .then(user -> {
                user.getHome().set(player.getLocation());
                context.reply(Messages.HOME_UPDATED);
            })
            .except(e -> context.reply(Messages.INTERNAL_ERROR));
    }

    @Override
    public Completion onTabComplete(@NotNull CommandContext context) {
        return Completion.EMPTY;
    }
}
