package ee.yoursit.core.command.bukkit.impl.message;

import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.command.bukkit.api.Command;
import ee.yoursit.core.command.bukkit.api.CommandContext;
import ee.yoursit.core.command.bukkit.api.CommandInfo;
import ee.yoursit.core.command.bukkit.api.Completion;
import ee.yoursit.core.config.Messages;
import ee.yoursit.core.data.DataManager;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

import java.util.Arrays;
import java.util.stream.Collectors;

@CommandInfo(name = "message", aliases = {"msg", "m", "pm", "dm"})
public class MessageCommand extends Command {
    @Override
    public void onCommand(@NotNull CommandContext context) throws Exception {
        if (context.size() < 2) {
            context.reply(Messages.PRIVATE_MESSAGE_USAGE);
            return;
        }

        Player player = context.getPlayer();
        Player target = context.getPlayer(0).get();

        if (target == null) {
            context.reply(Messages
                .PLAYER_NOT_ONLINE
                .replace("{player}", context.getStringRaw(0)));
            return;
        }

        String message = Arrays.stream(context.getData())
            .skip(1)
            .collect(Collectors.joining(" "));

        player.sendMessage(Messages.PRIVATE_MESSAGE_SEND
            .replace("{player}", target.getName())
            .replace("{message}", message));

        target.sendMessage(Messages.PRIVATE_MESSAGE_RECEIVE
            .replace("{player}", player.getName())
            .replace("{message}", message));

        DataManager dataManager = YsmpCore.INSTANCE.getDataManager();
        dataManager.get(player).setLastMessenger(target.getUniqueId());
        dataManager.get(target).setLastMessenger(player.getUniqueId());
    }

    @Override
    public Completion onTabComplete(@NotNull CommandContext context) {
        return Completion.PLAYERS;
    }
}
