package ee.yoursit.core.command.bukkit.impl.message;

import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.command.bukkit.api.Command;
import ee.yoursit.core.command.bukkit.api.CommandContext;
import ee.yoursit.core.command.bukkit.api.CommandInfo;
import ee.yoursit.core.command.bukkit.api.Completion;
import ee.yoursit.core.config.Messages;
import ee.yoursit.core.data.PlayerData;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

import java.util.Arrays;
import java.util.stream.Collectors;

@CommandInfo(name = "reply", aliases = {"r", "repl"})
public class ReplyCommand extends Command {
    @Override
    public void onCommand(@NotNull CommandContext context) throws Exception {
        Player player = context.getPlayer();
        PlayerData data = YsmpCore.INSTANCE
            .getDataManager()
            .get(player);

        Player messenger = data.getLastMessenger();
        if (messenger == null) {
            context.reply(Messages.PRIVATE_MESSAGE_NO_OPEN_CHANNELS);
            return;
        }

        String message = String.join(" ", context.getData());

        player.sendMessage(Messages.PRIVATE_MESSAGE_SEND
            .replace("{player}", messenger.getName())
            .replace("{message}", message));

        messenger.sendMessage(Messages.PRIVATE_MESSAGE_RECEIVE
            .replace("{player}", player.getName())
            .replace("{message}", message));

        YsmpCore.INSTANCE
            .getDataManager()
            .get(messenger)
            .setLastMessenger(player.getUniqueId());
    }

    @Override
    public Completion onTabComplete(@NotNull CommandContext context) throws Exception {
        return Completion.PLAYERS;
    }
}
