package ee.yoursit.core.command.bukkit.impl.teleport;

import dev.inventex.octa.data.convertible.Convertible;
import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.command.bukkit.api.Command;
import ee.yoursit.core.command.bukkit.api.CommandContext;
import ee.yoursit.core.command.bukkit.api.CommandInfo;
import ee.yoursit.core.command.bukkit.api.Completion;
import ee.yoursit.core.config.Messages;
import ee.yoursit.core.data.PlayerData;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

import java.util.Map;
import java.util.Objects;
import java.util.UUID;

@CommandInfo(name = "tpaccept")
public class TeleportAccept extends Command {
    @Override
    public void onCommand(@NotNull CommandContext context) throws Exception {
        PlayerData data = YsmpCore.INSTANCE
            .getDataManager()
            .get(context.getPlayer());

        Map<UUID, Long> teleportRequests = data.getTeleportRequests();

        if (teleportRequests.isEmpty()) {
            context.reply(Messages.TELEPORT_NO_REQUESTS);
            return;
        }

        Convertible<String, Player> targetParam = context.getPlayer(0);
        Player player = context.getPlayer();
        Player target;

        if (!targetParam.isEmpty())
            target = targetParam.get();
        else {
            UUID next = teleportRequests
                .keySet()
                .iterator()
                .next();
            target = Bukkit.getPlayer(next);
        }

        if (target == null) {
            if (targetParam.isEmpty())
                context.reply(Messages.TELEPORT_NO_REQUESTS);
            else
                context.reply(Messages
                    .TELEPORT_NO_REQUEST_FROM
                    .replace("{player}", context.getStringRaw(0)));
            return;
        }

        target.teleport(player.getLocation());

        target.sendMessage(Messages
            .TELEPORT_ACCEPT_SEND
            .replace("{player}", player.getName()));
        player.sendMessage(Messages
            .TELEPORT_ACCEPT_RECEIVE
            .replace("{player}", target.getName()));

        data.removeTeleportRequest(target);
    }

    @Override
    public Completion onTabComplete(@NotNull CommandContext context) {
        PlayerData data = YsmpCore.INSTANCE
            .getDataManager()
            .get(context.getPlayer());

        return Completion.of(data
            .getTeleportRequests()
            .keySet()
            .stream()
            .map(Bukkit::getPlayer)
            .filter(Objects::nonNull)
            .map(Player::getName));
    }
}
