package ee.yoursit.core.command.bukkit.impl.teleport;

import dev.inventex.octa.data.convertible.Convertible;
import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.command.bukkit.api.Command;
import ee.yoursit.core.command.bukkit.api.CommandContext;
import ee.yoursit.core.command.bukkit.api.CommandInfo;
import ee.yoursit.core.command.bukkit.api.Completion;
import ee.yoursit.core.config.Messages;
import ee.yoursit.core.data.PlayerData;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

@CommandInfo(name = "tpa")
public class TeleportRequest extends Command {
    @Override
    public void onCommand(@NotNull CommandContext context) {
        Convertible<String, Player> playerArg = context.getPlayer(0);
        if (playerArg.isEmpty()) {
            context.reply(Messages.TELEPORT_REQUEST_USAGE);
            return;
        }

        Player player = context.getPlayer();
        Player target = playerArg.getOrDefault(null);

        if (target == null) {
            context.reply(Messages.PLAYER_NOT_ONLINE);
            return;
        }

        PlayerData targetData = YsmpCore.INSTANCE
            .getDataManager()
            .get(target);

        if (targetData.getTeleportRequest(player) != null) {
            context.reply(Messages
                .TELEPORT_REQUEST_ALREADY
                .replace("{player}", target.getName()));
            return;
        }

        targetData.addTeleportRequest(player);

        context.reply(Messages.TELEPORT_REQUEST_SEND
            .replace("{player}", target.getName()));
        target.sendMessage(Messages.TELEPORT_REQUEST_RECEIVE
            .replace("{player}", target.getName()));
    }

    @Override
    public Completion onTabComplete(@NotNull CommandContext context) {
        return Completion.PLAYERS;
    }
}
