package ee.yoursit.core.command.discord;

import dev.inventex.discord.command.slash.CommandContext;
import dev.inventex.discord.command.slash.SlashCommand;
import dev.inventex.discord.command.slash.SlashCommandInfo;
import ee.yoursit.core.config.Messages;
import ee.yoursit.core.util.Constants;
import net.dv8tion.jda.api.EmbedBuilder;
import net.dv8tion.jda.api.entities.MessageEmbed;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import java.util.Collection;
import java.util.stream.Collectors;

@SlashCommandInfo(name = "players", description = "List the online players on the server.")
public class PlayersCommand extends SlashCommand {
    @Override
    public void execute(CommandContext context) {
        Collection<? extends Player> onlinePlayers = Bukkit.getOnlinePlayers();
        String players = onlinePlayers
            .stream()
            .map(Player::getName)
            .collect(Collectors.joining(", "));

        if (onlinePlayers.isEmpty())
            players = Messages.NO_PLAYERS_ONLINE;

        MessageEmbed embed = new EmbedBuilder()
            .setTitle("Online Players")
            .setDescription(players)
            .setColor(Constants.TRANSPARENT)
            .build();

        context
            .getInteraction()
            .replyEmbeds(embed)
            .queue();
    }
}
