package ee.yoursit.core.config;

public class Messages {
    public static String INTERNAL_ERROR;

    public static String PLAYER_JOIN, PLAYER_LEAVE;

    public static String PLAYER_NOT_ONLINE, NO_PLAYERS_ONLINE, NOT_A_USER, ALREADY_USER;

    public static String TELEPORT_REQUEST_SEND, TELEPORT_REQUEST_RECEIVE, TELEPORT_REQUEST_USAGE,
                         TELEPORT_REQUEST_ALREADY;

    public static String TELEPORT_ACCEPT_SEND, TELEPORT_ACCEPT_RECEIVE;
    public static String TELEPORT_DECLINE_SEND, TELEPORT_DECLINE_RECEIVE;

    public static String TELEPORT_NO_REQUESTS, TELEPORT_NO_REQUEST_FROM;

    public static String PRIVATE_MESSAGE_SEND, PRIVATE_MESSAGE_RECEIVE, PRIVATE_MESSAGE_USAGE,
                         PRIVATE_MESSAGE_NO_OPEN_CHANNELS;

    public static String HOME_UPDATED, HOME_TELEPORTING, HOME_NOT_SET, HOME_DELETED;

    public static String AUTO_SLEEP;

    public static String BANNED_FROM_SERVER, NOT_WHITELISTED, UNABLE_TO_FETCH;

    public static String ACTIVITY_PLAYERS, ACTIVITY_DISCORD, ACTIVITY_ADDRESS;

    public static String NO_SUCH_USER, NO_PERMISSION;

    public static String INVITE_LIMIT_EXCEEDED, INVITE_NOT_FOUND, INVITE_NOT_ON_GUILD,
                         INVITE_VERIFIED, INVITE_VERIFICATION, INVITE_ALREADY_VERIFYING,
                         INVITE_ALREADY_VERIFIED, INVITE_USE_VERIFY, INVITE_VERIFY_TIMEOUT,
                         INVITE_INVALID_CODE, INVITE_NOT_JOINED_GUILD, INVITE_ALREADY_VERIFYING_SELF;

    public static String GROUP_USAGE, GROUP_NOT_EXISTS,
                         GROUP_CREATE_USAGE, GROUP_CREATE_ALREADY_EXISTS, GROUP_CREATE_CREATED,
                         GROUP_DELETE_USAGE, GROUP_DELETE_NOT_EXISTS, GROUP_DELETE_DELETED,
                         GROUP_LIST, GROUP_NO_GROUPS,
                         GROUP_META_USAGE, GROUP_META_INFO,
                         GROUP_META_PREFIX_USAGE, GROUP_META_PREFIX_SET,
                         GROUP_META_SUFFIX_USAGE, GROUP_META_SUFFIX_SET,
                         GROUP_META_TAB_PREFIX_USAGE, GROUP_META_TAB_PREFIX_SET,
                         GROUP_META_TAB_SUFFIX_USAGE, GROUP_META_TAB_SUFFIX_SET,
                         GROUP_PERMISSION_USAGE,
                         GROUP_PERMISSION_SET_USAGE, GROUP_PERMISSION_SET_UPDATED,
                         GROUP_PERMISSION_UNSET_USAGE, GROUP_PERMISSION_UNSET_UPDATED,
                         GROUP_GRANT_USAGE, GROUP_GRANT_GRANTED;

    public static void init(Config config) {
        INTERNAL_ERROR = config.getF("internal-error");

        PLAYER_JOIN = config.getF("player-join");
        PLAYER_LEAVE = config.getF("player-leave");

        PLAYER_NOT_ONLINE = config.getF("player-not-online");
        NO_PLAYERS_ONLINE = config.getF("no-players-online");
        NOT_A_USER = config.getF("not-a-user");
        ALREADY_USER = config.getF("already-user");

        TELEPORT_REQUEST_SEND = config.getF("teleport-request.send");
        TELEPORT_REQUEST_RECEIVE = config.getF("teleport-request.receive");
        TELEPORT_REQUEST_USAGE = config.getF("teleport-request.usage");
        TELEPORT_REQUEST_ALREADY = config.getF("teleport-request.already");

        TELEPORT_NO_REQUESTS = config.getF("teleport.no-requests");
        TELEPORT_NO_REQUEST_FROM = config.getF("teleport.no-request-from");

        TELEPORT_ACCEPT_SEND = config.getF("teleport-accept.send");
        TELEPORT_ACCEPT_RECEIVE = config.getF("teleport-accept.receive");

        TELEPORT_DECLINE_SEND = config.getF("teleport-decline.send");
        TELEPORT_DECLINE_RECEIVE = config.getF("teleport-decline.receive");

        PRIVATE_MESSAGE_SEND = config.getF("private-message.send");
        PRIVATE_MESSAGE_RECEIVE = config.getF("private-message.receive");
        PRIVATE_MESSAGE_USAGE = config.getF("private-message.usage");
        PRIVATE_MESSAGE_NO_OPEN_CHANNELS = config.getF("private-message.no-open-channels");

        HOME_UPDATED = config.getF("home.updated");
        HOME_TELEPORTING = config.getF("home.teleporting");
        HOME_NOT_SET = config.getF("home.not-set");
        HOME_DELETED = config.getF("home.deleted");

        AUTO_SLEEP = config.getF("auto-sleep");

        BANNED_FROM_SERVER = config.getF("banned-from-server");
        NOT_WHITELISTED = config.getF("not-whitelisted");
        UNABLE_TO_FETCH = config.getF("unable-to-fetch");

        ACTIVITY_PLAYERS = config.getF("activity.players");
        ACTIVITY_DISCORD = config.getF("activity.discord");
        ACTIVITY_ADDRESS = config.getF("activity.address");

        NO_SUCH_USER = config.getF("no-such-user");
        NO_PERMISSION = config.getF("no-permission");

        INVITE_LIMIT_EXCEEDED = config.getF("invite.limit-exceeded");
        INVITE_NOT_FOUND = config.getF("invite.not-found");
        INVITE_NOT_ON_GUILD = config.getF("invite.not-on-guild");
        INVITE_VERIFIED = config.getF("invite.verified");
        INVITE_VERIFICATION = config.getF("invite.verification");
        INVITE_ALREADY_VERIFYING = config.getF("invite.already-verifying");
        INVITE_ALREADY_VERIFIED = config.getF("invite.already-verified");
        INVITE_USE_VERIFY = config.getF("invite.use-verify");
        INVITE_VERIFY_TIMEOUT = config.getF("invite.verify-timeout");
        INVITE_INVALID_CODE = config.getF("invite.invalid-code");
        INVITE_NOT_JOINED_GUILD = config.getF("invite.not-joined-guild");
        INVITE_ALREADY_VERIFYING_SELF = config.getF("invite.already-verifying-self");

        GROUP_USAGE = config.getF("group.usage");
        GROUP_NOT_EXISTS = config.getF("group.not-exists");

        GROUP_CREATE_USAGE = config.getF("group.create.usage");
        GROUP_CREATE_ALREADY_EXISTS = config.getF("group.create.already-exists");
        GROUP_CREATE_CREATED = config.getF("group.create.created");

        GROUP_DELETE_USAGE = config.getF("group.delete.usage");
        GROUP_DELETE_NOT_EXISTS = config.getF("group.delete.not-exists");
        GROUP_DELETE_DELETED = config.getF("group.delete.deleted");

        GROUP_LIST = config.getF("group.list");
        GROUP_NO_GROUPS = config.getF("group.no-groups");

        GROUP_META_USAGE = config.getF("group.meta.usage");
        GROUP_META_INFO = config.getF("group.meta.info");

        GROUP_META_PREFIX_USAGE = config.getF("group.meta.prefix.usage");
        GROUP_META_PREFIX_SET = config.getF("group.meta.prefix.set");

        GROUP_META_TAB_PREFIX_USAGE = config.getF("group.meta.tab-prefix.usage");
        GROUP_META_TAB_PREFIX_SET = config.getF("group.meta.tab-prefix.set");

        GROUP_META_TAB_SUFFIX_USAGE = config.getF("group.meta.tab-suffix.usage");
        GROUP_META_TAB_SUFFIX_SET = config.getF("group.meta.tab-suffix.set");

        GROUP_PERMISSION_USAGE = config.getF("group.permission.usage");

        GROUP_PERMISSION_SET_USAGE = config.getF("group.permission.set.usage");
        GROUP_PERMISSION_SET_UPDATED = config.getF("group.permission.set.updated");

        GROUP_PERMISSION_UNSET_USAGE = config.getF("group.permission.unset.usage");
        GROUP_PERMISSION_UNSET_UPDATED = config.getF("group.permission.unset.updated");

        GROUP_GRANT_USAGE = config.getF("group.grant.usage");
        GROUP_GRANT_GRANTED = config.getF("group.grant.granted");
    }
}
