package ee.yoursit.core.database.entity.impl;

import com.mongodb.client.MongoCollection;
import com.mongodb.client.model.Filters;
import ee.yoursit.core.database.entity.api.Entity;
import ee.yoursit.core.database.entity.api.EntityProperty;
import ee.yoursit.core.database.entity.api.MapEntityProperty;
import lombok.Getter;
import lombok.Setter;
import org.bson.Document;
import org.bson.conversions.Bson;

import java.util.Map;

import static com.mongodb.client.model.Filters.eq;

@Getter
public class Group implements Entity {
    @Setter
    private static MongoCollection<Document> collection;

    private EntityProperty<String> name;

    private EntityProperty<String> prefix, suffix;
    private EntityProperty<String> tabPrefix, tabSuffix;

    private MapEntityProperty<String, Boolean> permissions;

    public static Bson query(String name) {
        return eq("name", name);
    }

    @Override
    public Bson query() {
        return Filters.eq("name", name.get());
    }

    @Override
    public MongoCollection<Document> collection() {
        return collection;
    }
}
