package ee.yoursit.core.database.entity.impl;

import com.mongodb.client.MongoCollection;
import com.mongodb.client.model.Filters;
import ee.yoursit.core.database.entity.api.Entity;
import ee.yoursit.core.database.entity.api.EntityProperty;
import lombok.Getter;
import lombok.Setter;
import org.bson.Document;
import org.bson.conversions.Bson;

@Getter
public class Invite implements Entity {
    @Setter
    static MongoCollection<Document> collection;

    private EntityProperty<String> code;
    private EntityProperty<Boolean> used;
    private EntityProperty<String> creator;

    @Override
    public Bson query() {
        return Filters.eq("code", code.get());
    }

    public static Bson query(String code) {
        return Filters.eq("code", code);
    }

    @Override
    public MongoCollection<Document> collection() {
        return collection;
    }
}
