package ee.yoursit.core.database.entity.impl;

import com.mongodb.client.MongoCollection;
import com.mongodb.client.model.Filters;
import ee.yoursit.core.database.entity.api.Entity;
import ee.yoursit.core.database.entity.api.EntityProperty;
import lombok.Getter;
import lombok.Setter;
import org.bson.Document;
import org.bson.conversions.Bson;

@Getter
public class Verification implements Entity {
    @Setter
    private static MongoCollection<Document> collection;

    private EntityProperty<Long> discordId;
    private EntityProperty<String> username;
    private EntityProperty<String> code;
    private EntityProperty<Long> creation;

    @Override
    public Bson query() {
        return Filters.eq("code", code.get());
    }

    public static Bson queryCode(String code) {
        return Filters.eq("code", code);
    }

    public static Bson queryName(String name) {
        return Filters.eq("username", name);
    }

    public static Bson queryId(long discordId) {
        return Filters.eq("discordId", discordId);
    }

    @Override
    public MongoCollection<Document> collection() {
        return collection;
    }
}
