package ee.yoursit.core.database.service;

import dev.inventex.octa.concurrent.future.Future;
import ee.yoursit.core.YsmpCore;
import ee.yoursit.core.database.entity.api.EntitySerializer;
import ee.yoursit.core.database.entity.impl.User;
import org.bson.Document;

import java.util.UUID;

public class UserService {
    public Future<User> getUser(UUID uuid) {
        return Future.tryCompleteAsync(() -> {
            Document document = YsmpCore.INSTANCE
                .getDatabase()
                .getUsers()
                .find(User.query(uuid))
                .first();

            return EntitySerializer.deserialize(document, User.class);
        });
    }

    public Future<User> getUser(String name) {
        return Future.tryCompleteAsync(() -> {
            Document document = YsmpCore.INSTANCE
                .getDatabase()
                .getUsers()
                .find(User.query(name))
                .first();

            return EntitySerializer.deserialize(document, User.class);
        });
    }

    public Future<Void> addUser(User user) {
        return Future.completeAsync(() -> {
            Document document = EntitySerializer.serialize(user);
            YsmpCore.INSTANCE
                .getDatabase()
                .getUsers()
                .insertOne(document);
        });
    }
}
