package ee.yoursit.core.util;

import lombok.RequiredArgsConstructor;

import java.util.Random;

@RequiredArgsConstructor
public class InviteGenerator {
    private static final String LETTERS = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    private static final String DIGITS = "0123456789";

    private static final char[] CHARS = (LETTERS + DIGITS).toCharArray();

    private static final Random random = new Random();

    private final int length;
    private final int count;

    public String generate() {
        char[] buffer = new char[length * count + (count - 1)];
        for (int index = 0, offset = 0; index < buffer.length; index++) {
            if (offset == length) {
                buffer[index] = '-';
                offset = 0;
            } else {
                buffer[index] = CHARS[random.nextInt(CHARS.length)];
                offset++;
            }
        }
        return new String(buffer);
    }
}